VERSION 5.00
Begin VB.Form Form1 
   BorderStyle     =   1  'Fest Einfach
   Caption         =   "Mehrere Dateien in einer archivieren"
   ClientHeight    =   855
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   1815
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   855
   ScaleWidth      =   1815
   StartUpPosition =   3  'Windows-Standard
   Begin VB.CommandButton cmdExtractIt 
      Caption         =   "Extrahieren"
      Height          =   255
      Left            =   120
      TabIndex        =   1
      Top             =   480
      Width           =   1575
   End
   Begin VB.CommandButton cmdPackIt 
      Caption         =   "Packen"
      Height          =   255
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   1575
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

' VORSICHT:
' Dieser Tipp zeigt eine /sehr einfache/ Mglichkeit, eine Art
' Dateiarchiv zu erstellen. Das ist fr kleine Dateipakete
' durchaus ausreichend, aber sobald es entweder sehr viele
' oder sehr grosse Dateien sind, sollte man sie niemals
' alle gleichzeitig im RAM ablegen mssen!

' Gepackt werden bei diesem Beispiel die Dateien
' "bild.bmp" und "textdatei.txt" im Programmordner.

Private Type PackFile           ' Type fr die einzelnen Dateien
    FileName As String          ' Hier steht der Dateiname der Datei
    Contents As String          ' Hier der Inhalt
End Type

Private Type myPack             ' Type fr die gepackte Datei
    Files() As PackFile         ' Ein Array fr die Dateien
    UBoundFiles As Long         ' und die Obergrenze des Array
End Type

Private APath As String

Private Sub cmdPackIt_Click()
    Dim Files(1) As String      ' Wir haben 2 Dateien zum packen
    
    Files(0) = APath & "textdatei.txt"
    Files(1) = APath & "bild.bmp"
    
    Call PackIt(Files(), APath & "gepackt.sz")
End Sub

Private Sub cmdExtractIt_Click()
    Call ExtractIt(APath & "gepackt.sz", APath)
End Sub

' Funktion zum Packen
Private Function PackIt(Files() As String, DestFile As String)
    Dim i As Long
    Dim FN As Integer
    Dim zw As String
    Dim Pack As myPack
    
    Me.MousePointer = vbHourglass
    
    Pack.UBoundFiles = UBound(Files)        ' Anzahl der Files
    ReDim Pack.Files(Pack.UBoundFiles)
    
    For i = 0 To UBound(Files())
        FN = FreeFile
        Open Files(i) For Binary As #FN     ' Einzelne Dateien ffnen,
        
        zw = Space(LOF(FN))                 ' String vordimensionieren,
        Get #FN, , zw                       ' einlesen,
        Pack.Files(i).Contents = zw         ' Inhalt in den UDT packen,
        Pack.Files(i).FileName = Files(i)   ' den FileNamen ebenfalls
        
        Close #FN
    Next i
    
    FN = FreeFile
    Open DestFile For Binary As #FN         ' Ziel Datei ffnen
    
    Put #FN, , Pack                         ' und den UDT speichern
    
    Close #FN
    
    Me.MousePointer = vbDefault
End Function

'Funktion zum entpacken
Private Function ExtractIt(Source As String, DestPath As String)
    Dim i As Long
    Dim FN As Long
    Dim UBF As Long
    Dim Pack As myPack
    
    FN = FreeFile
    Open Source For Binary As #FN           ' Gepackte Datei ffnen,
    
    Get #FN, LOF(FN) - 3, UBF               ' Anzahl der Files auslesen,
    
    Close
    
    ReDim Pack.Files(UBF)                   ' UDT dimensionieren,
    
    Open Source For Binary As #FN
    
    Get #FN, , Pack                         ' Inhalt in den UDT
    
    Close
    
    For i = 0 To UBF                        ' Einzelne Dateien,
        FN = FreeFile
        Open DestPath & GetFileName(Pack.Files(i).FileName) _
          For Binary As #FN                 ' ffnen/erstellen,
        
        Put #FN, , Pack.Files(i).Contents   ' Inhalt speichern
        
        Close #FN
    Next i
End Function

'Funktion um den Dateinamen aus dem Pfad zu "extrahieren"
Private Function GetFileName(xFile As String) As String
    Dim lastbs As Long          ' Position des letzten Backslashes (\)
    
    lastbs = InStrRev(xFile, "\")
    GetFileName = Mid(xFile, lastbs + 1)
End Function


Private Sub Form_Load()
    APath = App.Path & IIf(Right(App.Path, 1) = "\", "", "\")
End Sub
